import { CredentialsSource } from '../../easJson';
import { AppLookupParams } from '../api/IosApi';
import { CredentialsProvider } from './provider';
export interface iOSCredentials {
    provisioningProfile: string;
    distributionCertificate: {
        certP12: string;
        certPassword: string;
    };
}
export default class iOSCredentialsProvider implements CredentialsProvider {
    private projectDir;
    private app;
    readonly platform = "ios";
    private readonly ctx;
    private credentials?;
    constructor(projectDir: string, app: AppLookupParams);
    initAsync(): Promise<void>;
    hasRemoteAsync(): Promise<boolean>;
    hasLocalAsync(): Promise<boolean>;
    isLocalSyncedAsync(): Promise<boolean>;
    getCredentialsAsync(src: CredentialsSource.LOCAL | CredentialsSource.REMOTE): Promise<iOSCredentials>;
    private getLocalAsync;
    private getRemoteAsync;
}
